pro cali_telluric,datapath,rootname,telpath,telname,outpath,outname,temp,telname2,bandJ=bandJ,bandH=bandH,bandK=bandK,bandY=bandY,checkyes=checkyes
 
;; 
;;; Purpose: 
;;; Derive sensitivity function from telluric stars for MOSFIRE 
;
;; functions called: getwlcd.pro
;; Default is for bandK
;;; HISTORY 
;;; Scartched in Jan 2014, bug report to T.-T. Yuan; tiantian.yuan@anu.edu.au
;;; last modification: Mar 13, 2014
;;;;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
fudge_shift=0

device, decomposed=0
loadcolors
;setcolors,/inverse
;; step 1 create bb spec 
theorypath=outpath+'mosrunall_libpro/'  ;; ### NO NEED TO EDIT THIS PATH ANYMORE 
theorypath=theorypath ;'/Users/yuantt/worktools/IDLpros/selflib/Moircs_datareduction/'
theorydat= 'trans_16_15.dat'


;; ;;;; set the wavelength range using the science frame
 filedat=datapath+rootname
 fits_read,filedat+'.fits',specdat,header_dat
  spec1d_dat=total(specdat,2,/nan)
  wavedat=getwlcd(spec1d_dat,header_dat)   ;;; moircsfire 

;;; Looks like MOSPY rectify the spectrum such that all the slitlets including
;;; Longslits have the same wavelength solution of xpixel to lambda ? 

telpath=telpath;
telname=telname;'longslit_131225_HD108519_K_A-B'
if n_elements(telname2)  eq 0 then print, ' use old standard star format, incomplete wavelength coverage'

file1=telpath+telname
fits_read,file1+'.fits',spec2d_telluric,header_t
window,0
  spec2dcut=spec2d_telluric ;[where(wavex ge lowcut and wavex le hicut),*]
  space_profile=median(spec2dcut,dimension=1)
  plot,space_profile,title='Space Profile of a ratining star spec.'
  print,'Click at a peak of the profile.'
  cursor,x,y
  wait,0.1
  space_profile_cut=space_profile[x-20:x+20]
  xarray=findgen(41)-20.
  yfit=mpfitpeak(xarray,space_profile_cut,A,sigma=sigma,nterms=4,/positive,errmsg=errmsg)
  plot,xarray,space_profile_cut,psym=10;,xtickformat='(A1)'
  oplot,xarray,yfit,color=2
  wait,1.  
  x+=a[1]
  cen=x
  width=a[2]
  print,'center & FWHM ',cen,width*2.3548
  spec2d_cut=spec2dcut[*,cen-width*2.3548/2:cen+width*2.3548/2]
  spec1d=total(spec2d_cut,2,/nan);/1.d-17
 
;stop
header=header_t    ;;; now that the solution is contained in the star's header ...
wave=getwlcd(spec1d,header)  ;;; moircsfire ;; ;318.498=MANUUAL shifting for Kband


 
if n_elements(telname2)  gt 0 then begin

file2=telpath+telname2
fits_read,file2+'.fits',spec2d_telluric2,header_t2
window,0
  spec2dcut2=spec2d_telluric2 ;[where(wavex ge lowcut and wavex le hicut),*]
  space_profile2=median(spec2dcut2,dimension=1)
  plot,space_profile2,title='Space Profile of a ratining star spec.'
  print,'Click at a peak of the profile.'
  cursor,x,y
  wait,0.1
  space_profile_cut2=space_profile2[x-20:x+20]
  xarray2=findgen(41)-20.
  yfit2=mpfitpeak(xarray2,space_profile_cut2,A,sigma=sigma,nterms=4,/positive,errmsg=errmsg)
  plot,xarray2,space_profile_cut2,psym=10;,xtickformat='(A1)'
  oplot,xarray2,yfit2,color=2
  wait,1.  
  x+=a[1]
  cen=x
  width=a[2]
  print,'center & FWHM ',cen,width*2.3548
  
  spec2d_cut2=spec2dcut2[*,cen-width*2.3548/2:cen+width*2.3548/2]
  spec1d2=total(spec2d_cut2,2,/nan);/1.d-17
 
;stop
header2=header_t2    ;;; now that the solution is contained in the star's header ...
wave2=getwlcd(spec1d2,header2)  ;;; moircsfire ;; ;318.498=MANUUAL shifting for Kband




if defined(bandK) then begin

   dex=where(wave gt 23000 and spec1d eq 0,check1)
   if check1 le 0 then print,' problem finding K band edge, stop and check'
   if check1 le 0 then stop
   dex1=dex[0]-10  ;; avoid edge drop off
   wave_leftcut=wave(where(wave eq wave[dex1]))
   wave_number=wave_leftcut[0]
   dexuse=where(wave gt wave_number)
spec1d[dexuse]=spec1d2[dexuse]
   
endif


if defined(bandJ) then begin
   dex=where(wave gt 13450 and spec1d eq 0,check1)
   if check1 le 0 then print,' problem finding K band edge, stop and check'
   if check1 le 0 then stop
   dex1=dex[0]-10  ;; avoid edge drop off
   wave_leftcut=wave(where(wave eq wave[dex1]))
   wave_number=wave_leftcut[0]
   dexuse=where(wave gt wave_number)
spec1d[dexuse]=spec1d2[dexuse]
   
endif


if defined(bandH) then begin
   dex=where(wave gt 17580 and spec1d eq 0,check1)
   if check1 le 0 then print,' problem finding K band edge, stop and check'
   if check1 le 0 then stop
   dex1=dex[0]-10  ;; avoid edge drop off
   wave_leftcut=wave(where(wave eq wave[dex1]))
   wave_number=wave_leftcut[0]
   dexuse=where(wave gt wave_number)
spec1d[dexuse]=spec1d2[dexuse]
   
endif

if defined(bandY) then begin
   dex=where(wave gt 11150 and spec1d eq 0,check1)
   if check1 le 0 then print,' problem finding K band edge, stop and check'
   if check1 le 0 then stop
   dex1=dex[0]-10  ;; avoid edge drop off
   wave_leftcut=wave(where(wave eq wave[dex1]))
   wave_number=wave_leftcut[0]
   dexuse=where(wave gt wave_number)
spec1d[dexuse]=spec1d2[dexuse]
   
endif

endif






;plot,wave,spec1d
;oplot,wave2,spec1d2,color=2


;stop
   










window,0
;stop
;;; plotting wavelength range is defined using the science data
plot,wave,spec1d,charsize=2,color=3,xra=[min(wavedat),max(wavedat)],yra=[min(spec1d)-1,max(spec1d)+1],/xs,/ys,title=rootname
writefits,outpath+'telluric_'+outname+'_1D.fits',spec1d,header

;;adapted from OSIRIS reduction code ;;;;
; lines =10.*[901.2,922.6,954.3,1004.6,1093.5, 1281.4, 1874.5, $                       ; Paschen series
 ;           1570.7, 1588.7, 1611.5, 1641.3, 1681.3, 1736.9, 1818.1, 1945.1, 2166.1]  ; Brackett series
 lines =10.*[901.2,922.6,954.3,1004.6,1093.5, 1282.4, 1874.5, $                       ; Paschen series
            1570.7, 1588.7, 1611.5, 1641.3, 1681.3, 1736.9, 1818.1, 1945.1, 2166.1]  ; Brackett series

   numlines=size(lines,/dimensions)
   startpix=intarr(numlines[0])
   endpix = intarr(numlines[0])

for i=0,numlines[0]-1 do begin
     oplot,[lines[i],lines[i]],[-1.e6,1.e6],linestyle=3,color=2
     if lines[i] gt min(wave) and lines[i] le max(wave) then begin
     xyouts,lines[i],max(spec1d)*0.5,'  Hydrogen lines',color=2
     endif
endfor


readcol,theorypath+theorydat,lamda,flux_ori,skipline=2,format='d,d'

oplot,lamda*1.e4,flux_ori*max(spec1d),color=250
;stop

xyouts,2.1e4,max(spec1d)*0.8,' Theoretical Transmission at MK (white)',charsize=1.2
xyouts,2.1e4,max(spec1d)*0.6,' science raw 1D (Yellow)',charsize=1.2,color=3

 
       firstlam=sxpar(header,'CRVAL1',count=n)+fudge_shift
       dlam = sxpar(header,'CD1_1',n)
       firstpix=sxpar(header,'CRPIX1', count=n)
       sz = size(spec1d)
       x = findgen(sz[1]) ; location of data
       modx=fltarr(sz[1])
        modxb=modx
            spec1df=spec1d

      ; Loop through each line location
FOR  line = 0, numlines[0]-1 DO BEGIN
           ; Calculate pixel locations for all of the hydrogen lines within the
           ; spectrum. Fit between lam/1.007 and lam*1.007.
if (~defined(bandJ) AND ~defined(bandH)) OR defined(bandK) OR defined(bandY) then begin
 
           startpix[line] = fix( (((lines[line]/1.007)-firstlam)/dlam) + firstpix )
           endpix[line]   = fix( (((lines[line]*1.007)-firstlam)/dlam) + firstpix )
          ; endpix[15]=1220 
endif
;stop

if defined(bandJ) then begin
            startpix[line] = fix( (((lines[line]/1.008)-firstlam)/dlam) + firstpix )
           endpix[line]   = fix( (((lines[line]*1.016)-firstlam)/dlam) + firstpix )
endif

if defined(bandH) then begin
            startpix[line] = fix( (((lines[line]/1.005)-firstlam)/dlam) + firstpix )
           endpix[line]   = fix( (((lines[line]*1.005)-firstlam)/dlam) + firstpix )
endif
  



IF ( (startpix[line] ge 0) and (endpix[line] lt sz[1]) ) THEN BEGIN ; Line is in the spectrum


        if ~defined(bandJ) then begin
           data = spec1d[startpix[line]:endpix[line]]*1.d0
                                  model = gaussfit(wave[startpix[line]:endpix[line]],data,A)

                                  ESTIMATEs=A
                                                              ;  if line eq 14 then    ESTIMATES[2]=20

                              if line eq 15 then    ESTIMATES[2]=200
                       model = gaussfit(wave[startpix[line]:endpix[line]],data,A,ESTIMATES=ESTIMATES)
                       xxx=wave[startpix[line]:endpix[line]]
                       modx[startpix[line]:endpix[line]]=model
                       spec1d_sub =spec1df-modx
               spec1df[startpix[line]:endpix[line]]=spec1d_sub[startpix[line]:endpix[line]]+A[3]+A[4]*xxx+A[5]*xxx^2
        endif
        
        if defined(bandJ) then begin
                      data = spec1d[startpix[line]:endpix[line]]*1.d0
                       model = gaussfit(wave[startpix[line]:endpix[line]],data,A)
                       xw=wave[startpix[line]:endpix[line]]
;;                  model = A[0]*exp(-0.5*((x-A[1])/A[2])^2)          
                     modx[startpix[line]:endpix[line]]=model
                       spec1d_sub =spec1df-modx
              ; smok=where(xw gt 12796 and xw lt 12855.,ccc)  ;;;dirty work
              ; spec1d_sub[smok]=1;median(spec1d_sub[smok])
              ;spec1df[startpix[line]:endpix[line]]=spec1d_sub[startpix[line]:endpix[line]]+median(spec1df[startpix[line]:endpix[line]])
               spec1df[startpix[line]:endpix[line]]=spec1d_sub[startpix[line]:endpix[line]]+A[3]+A[4]*xw+A[5]*xw^2

  ;;; broad wings
                ESTIMATEs=[-1200,12826,200.,32600,-0.9,1.e-6]
                       data = spec1df[startpix[line]:endpix[line]]*1.d0
                      ;e data=median(data,5)
                       model = gaussfit(wave[startpix[line]:endpix[line]],data,A,ESTIMATES=ESTIMATES)
           ;    model = gaussfit(wave[startpix[line]:endpix[line]],data,A,nterms=4)
                         xw= wave[startpix[line]:endpix[line]]             
                         modxb[startpix[line]:endpix[line]]=model
;; plot,wave[startpix[line]:endpix[line]],data,color=2
;; oplot,wave[startpix[line]:endpix[line]],model,color=4
;; stop
                          spec1d_sub =spec1df-modxb
         ;     spec1df[startpix[line]:endpix[line]]=spec1d_sub[startpix[line]:endpix[line]]+A[3]
                spec1df[startpix[line]:endpix[line]]=smooth(spec1d_sub[startpix[line]:endpix[line]],5)+median(spec1df[startpix[line]:endpix[line]])
             ;   spec1df[startpix[line]:endpix[line]]=spec1d_sub[startpix[line]:endpix[line]]+A[3]+A[4]*xw+A[5]*xw^2
  
              smok=where(wave gt 12803.1 and wave lt 12862.1,ccc)  ;;;dirty work of removing extra profiles
               spec1df[smok]=modxb[smok];
        
      endif




          
  ENDIF
        
ENDFOR




window,1
plot,wave,spec1df,charsize=2,color=3,xra=[min(wave),max(wave)],yra=[min(spec1d)-1,max(spec1d)+1],/xs,/ys,title='Hydrogen lines removed'
oplot,wave,modx,color=2
;oplot,wave,modxb,color=2

;stop

temperature=temp;9480. 
       lam = dlam*(x-firstpix)+firstlam  ; Wavelength at each pixel
       lam = lam/1.d10 ; Wavelengths in meters
       dlam=dlam/1.d10 ; delta lam in meters
       hcokt = 0.014397/temperature
       bb = 1.0/(lam*lam*lam*lam*lam)
       bb = bb / (exp(hcokt/lam)-1.0)  ; This is proportional to flux
       mn = mean(bb) ; Calculate mean of bb
       bb = bb / mn
window, 2
spec1df_div=spec1df/bb
plot,wave,spec1df_div,charsize=2,color=3,xra=[min(wave),max(wave)],yra=[min(spec1d)-1,max(spec1d)+1],/xs,/ys,title='divide by B-body'
oplot,lamda*1.e4,flux_ori*max(spec1d),color=250
oplot,wave,spec1df,color=3
oplot,wave,spec1df_div,color=5


window,3
senscurve=spec1df_div

slength=3
if defined(bandY) then begin

senscurve=median(senscurve,slength)



endif else begin
senscurve=median(senscurve,slength)
endelse 
senscurve=smooth(senscurve,slength)




;;;;;;; 
  crval1=wave[0]
  cdelt1=wave[1]-wave[0]
  crpix1=1.
; header manipulation
  header_specwcs=header
  sxaddpar,header_specwcs,'CDELT1',cdelt1
  sxaddpar,header_specwcs,'CRPIX1',crpix1
  sxaddpar,header_specwcs,'CRVAL1',crval1
  sxaddpar,header_specwcs,'CUNIT1','Angstrom'
  sxaddpar,header_specwcs,'CD1_1',cdelt1
  sxaddpar,header_specwcs,'CD1_2',0.
 header_sens=header_specwcs
  ;; mwrfits,senscurve,outpath+'sen_HD108519_1d.fits',header_sens,/create
  ;; mwrfits,wave,outpath+'sens_HD108519_1d_wave.fits',header_sens,/create

;;; manually push the edge to longer wavelength ?
;; man=where(wave gt 23900.)
;; lman=lamda*1.4 & theman=where(lam gt 23900)
;; flux_the=flux_ori[where(lman ge min(wave) AND lam le max(wave))]
;; theo_rebin=interpol(flux_the,lman,wave) ; linear interpol without any options
;; senscurve[man] = theo_rebin[man]


    ; Normalize stellar spectrum
senscurve=senscurve/median(senscurve)
plot,wave,senscurve,color=3,title='Normalized Sensitivity Curve, smoothed by '+strmid(strc(slength),0,3)
oplot,lamda*1.e4,flux_ori*max(senscurve),color=250
for i=0,numlines[0]-1 do begin
     oplot,[lines[i],lines[i]],[-1.e6,1.e6],linestyle=3,color=2
     if lines[i] gt min(wave) and lines[i] le max(wave) then begin
     xyouts,lines[i],max(spec1d)*0.5,' check Hydrogen line positions',color=2
     endif
endfor



if defined(bandY) then begin
  fitpol=poly_fit(wave,senscurve,2,sig=sig)
;  yy=fitpol[0]+fitpol[1]*wave+fitpol[2]*wave^2
;  oplot,wave,yy,color=4
;;;senscurve=yy
;  senscurve=yy   ;;; wiggles are true
endif

;smooth2=where(wave ge XXX and le XXX)
;senscurve2=senscurve[smooth2]
;smooth_out=smooth(senscurve2,3)
;senscurve[smooth2]=smooth_out

  mwrfits,senscurve,outpath+'sens_'+outname+'_1d.fits',header_sens,/create
  mwrfits,wave,outpath+'sens_'+outname+'_1d_wave.fits',header_sens,/create

print,'@cali_telluric.pro --> sensivity curve sen*_1d.fits generated based on your input telluric stars ...'
print,outpath+'sens_'+outname+'_1d_wave.fits'
print,outpath+'sens_'+outname+'_1d.fits'

;window_to_ps,0,'test.eps'
if defined(checkyes) then begin
stop,' type .continue to close all windows' 
endif
;foreach window, getwindows() do window.close
;close,/all
wdelete,0
wdelete,1
wdelete,2
wdelete,3
end

