pro moscali_flux,pathsens,sensname,sensname_wave,datapath,rootname,fluxpath,fluxrootname,fluxrootname2,bbname,bbname_wave,magJ,magH,magK,tempf,filestd,$
              fluxconvt,bandJ=bandJ,bandH=bandH,bandK=bandK,bandY=bandY,plotyes=plotyes,usespec=usespec
;; 
;;;; For MOSFIRE  the units of the long slit star are 
;; in ADU per co-adds, us gaining = sys gain of 2.15
;; functions needed: getwlcd.pro

device, decomposed=0
loadcolors
temp=tempf
;; ;;;; set the wavelength range using the science frame
 filedat=datapath+rootname
 fits_read,filedat+'.fits',specdat,header_dat
  spec1d_dat=total(specdat,2,/nan)
  wavedat=getwlcd(spec1d_dat,header_dat)   ;;; moircsfire 

path=datapath


;;; Looks like MOSPY rectify the spectrum such that all the slitlets including
;;; Longslits have the same wavelength solution of xpixel to lambda ? 

fluxpath=fluxpath
fluxrootname=fluxrootname


if n_elements(fluxrootname2)  eq 0 then print, ' use old standard star format, incomplete wavelength coverage'



file1=fluxpath+fluxrootname
fits_read,file1+'.fits',spec2d_flux,header_t
exposure_star= 1.; sxpar(header_t,'TRUITIME')
gain=1.; sxpar(header_t,'SYSGAIN')


window,0
  spec2dcut=spec2d_flux ;[where(wavex ge lowcut and wavex le hicut),*]
  space_profile=median(spec2dcut,dimension=1)
  plot,space_profile,title='Space Profile of a ratining star spec.'
  print,'Click at a peak of the profile.'
  cursor,x,y
  wait,0.1
  space_profile_cut=space_profile[x-20:x+20]
  xarray=findgen(41)-20.
  yfit=mpfitpeak(xarray,space_profile_cut,A,sigma=sigma,nterms=4,/positive,errmsg=errmsg)
  plot,xarray,space_profile_cut,psym=10;,xtickformat='(A1)'
  oplot,xarray,yfit,color=2
  wait,1.  
  x+=a[1]
  cen=x
  width=a[2]
  print,'center & FWHM ',cen,width*2.3548
  spec2d_cut=spec2dcut[*,cen-width*2.3548/2:cen+width*2.3548/2]
  spec1d=total(spec2d_cut,2,/nan);/1.d-17
 wave=getwlcd(spec1d,header_t);+318.498   ;;; moircsfire ;; ;MANUUAL shifting


if n_elements(fluxrootname2)  gt 0 then begin
file2=fluxpath+fluxrootname2
fits_read,file2+'.fits',spec2d_flux2,header_t2
window,0
  spec2dcut2=spec2d_flux2 ;[where(wavex ge lowcut and wavex le hicut),*]
  space_profile2=median(spec2dcut2,dimension=1)
  plot,space_profile2,title='Space Profile of a ratining star spec.'
  print,'Click at a peak of the profile.'
  cursor,x,y
  wait,0.1
  space_profile_cut2=space_profile2[x-20:x+20]
  xarray2=findgen(41)-20.
  yfit2=mpfitpeak(xarray2,space_profile_cut2,A,sigma=sigma,nterms=4,/positive,errmsg=errmsg)
  plot,xarray2,space_profile_cut2,psym=10;,xtickformat='(A1)'
  oplot,xarray2,yfit2,color=2
  wait,1.  
  x+=a[1]
  cen=x
  width=a[2]
  print,'center & FWHM ',cen,width*2.3548
  
  spec2d_cut2=spec2dcut2[*,cen-width*2.3548/2:cen+width*2.3548/2]
  spec1d2=total(spec2d_cut2,2,/nan);/1.d-17
 
;stop
header2=header_t2    ;;; now that the solution is contained in the star's header ...
wave2=getwlcd(spec1d2,header2)  ;;; moircsfire ;; ;318.498=MANUUAL shifting for Kband





if defined(bandK) then begin
   dex=where(wave gt 23000 and spec1d eq 0,check1)
   if check1 le 0 then print,' problem finding K band edge, stop and check'
   if check1 le 0 then stop
   dex1=dex[0]-10  ;; avoid edge drop off
   wave_leftcut=wave(where(wave eq wave[dex1]))
   wave_number=wave_leftcut[0]
   dexuse=where(wave gt wave_number)
spec1d[dexuse]=spec1d2[dexuse]
   
endif



if defined(bandJ) then begin
   dex=where(wave gt 13450 and spec1d eq 0,check1)
   if check1 le 0 then print,' problem finding K band edge, stop and check'
   if check1 le 0 then stop
   dex1=dex[0]-10  ;; avoid edge drop off
   wave_leftcut=wave(where(wave eq wave[dex1]))
   wave_number=wave_leftcut[0]
   dexuse=where(wave gt wave_number)
spec1d[dexuse]=spec1d2[dexuse]
   
endif


if defined(bandH) then begin
   dex=where(wave gt 17580 and spec1d eq 0,check1)
   if check1 le 0 then print,' problem finding K band edge, stop and check'
   if check1 le 0 then stop
   dex1=dex[0]-10  ;; avoid edge drop off
   wave_leftcut=wave(where(wave eq wave[dex1]))
   wave_number=wave_leftcut[0]
   dexuse=where(wave gt wave_number)
spec1d[dexuse]=spec1d2[dexuse]
   
endif

if defined(bandY) then begin
   dex=where(wave gt 11150 and spec1d eq 0,check1)
   if check1 le 0 then print,' problem finding K band edge, stop and check'
   if check1 le 0 then stop
   dex1=dex[0]-10  ;; avoid edge drop off
   wave_leftcut=wave(where(wave eq wave[dex1]))
   wave_number=wave_leftcut[0]
   dexuse=where(wave gt wave_number)
spec1d[dexuse]=spec1d2[dexuse]
   
endif

endif



fudge_shift=0

;; if defined(bandK) then begin
;; fudge_shift=318.498 ;; for Kband default 
;; endif

;; if defined(bandJ) then begin
;; fudge_shift=-421.9362;+318.498-318.498-558.39330   ;;; moircsfire ;; ;MANUUAL shifting for Kban
;; endif

;; if defined(bandH) then begin
;; fudge_shift=+141.83677;+318.498-318.498-558.39330   ;;; moircsfire ;; ;MANUUAL shifting for Kban
;; endif


;wave=getwlcd(spec1d,header)+fudge_shift   ;;; moircsfire ;;
;;318.498=MANUUAL shifting for Kband


header=header_t    ;;; now that the solution is contained in the star's header ...
wave=getwlcd(spec1d,header)  ;;; moircsfire ;; ;318.498=MANUUAL shifting for Kband


;;;;; add, should divide the star by sensivity curve too
fits_read,pathsens+sensname,sens1d,hd1dsen
fits_read,pathsens+sensname_wave,wavelen_star,hd1dsen

;stop
  sens1d_rebin=interpol(sens1d,wavelen_star,wave) ; linear interpol without any options
sens1d_rebin=sens1d_rebin/median(sens1d_rebin)  ;renormalize after rebinning
ind=where (sens1d_rebin eq 0,ctt)
if ctt gt 0 then sens1d_rebin[ind]=!values.f_nan
        spec1d=spec1d/sens1d_rebin
;;;;; add, should divide the star by sensivity curve too

;stop
;fits_read, datapath+'lambda_solution_wave_stack_K_m131225_0587-0594.fits',wavesol,hdr
;wave=reform(wavesol[*,cen])
 ;;wave=getwlcd(spec1d,header_t)+318.498   ;;; moircsfire 

;stop
;;;change root name to match this 
okp=where(abs(spec1d) le 3*median(spec1d) AND wave gt min(wave)+200 AND wave lt max(wave)-100)

;okn=where(finite(spec1d,/NAN),complement=okp)

if keyword_set(plotyes) then window,1
if keyword_set(plotyes) then plot,wave,spec1d,charsize=2,color=3,xra=[min(wave),max(wave)],yra=[min(spec1d[okp])-1,max(spec1d[okp])+1],/xs,/ys,title='Flux Standard Raw'
;; ;;;
;; readcol,'BD.dat',wbd,fbd,format='(f,f)'
;; oplot,wbd,fbd/max(fbd[where(wbd gt 2.e4 and wbd le 2.4e4)])*5500,color=2
;; ;;;;
;; stop

joke=0     ;;;;Shall we remove the hydrogen absorption lines before flux calibration  ? Looks like we should ... if not, then set joke gt 0
;IF ~defined(usespec) THEN BEGIN
IF joke le 0 THEN BEGIN

; lines =10.*[901.2,922.6,954.3,1004.6,1093.5, 1281.4, 1874.5, $                       ; Paschen series
 ;           1570.7, 1588.7, 1611.5, 1641.3, 1681.3, 1736.9, 1818.1, 1945.1, 2166.1]  ; Brackett series
 lines =10.*[901.2,922.6,954.3,1004.6,1093.5, 1282.4, 1874.5, $                       ; Paschen series
            1570.7, 1588.7, 1611.5, 1641.3, 1681.3, 1736.9, 1818.1, 1945.1, 2166.1]  ; Brackett series

   numlines=size(lines,/dimensions)
   startpix=intarr(numlines[0])
   endpix = intarr(numlines[0])

for i=0,numlines[0]-1 do begin
  if keyword_set(plotyes) then   oplot,[lines[i],lines[i]],[-1.e6,1.e6],linestyle=3,color=2
endfor


       firstlam=sxpar(header,'CRVAL1',count=n)+fudge_shift
       dlam = sxpar(header,'CD1_1',n)
       firstpix=sxpar(header,'CRPIX1', count=n)
       sz = size(spec1d)
       x = findgen(sz[1]) ; location of data
      modx=fltarr(sz[1])
      modxb=modx
            spec1df=spec1d
      ; Loop through each line location
FOR  line = 0, numlines[0]-1 DO BEGIN
           ; Calculate pixel locations for all of the hydrogen lines within the
           ; spectrum. Fit between lam/1.007 and lam*1.007.
if (~defined(bandJ) AND ~defined(bandH)) OR defined(bandK) OR defined(bandY) then begin
 
           startpix[line] = fix( (((lines[line]/1.007)-firstlam)/dlam) + firstpix )
           endpix[line]   = fix( (((lines[line]*1.007)-firstlam)/dlam) + firstpix )
endif


if defined(bandJ) then begin
            startpix[line] = fix( (((lines[line]/1.008)-firstlam)/dlam) + firstpix )
           endpix[line]   = fix( (((lines[line]*1.016)-firstlam)/dlam) + firstpix )
endif

if defined(bandH) then begin
            startpix[line] = fix( (((lines[line]/1.005)-firstlam)/dlam) + firstpix )
           endpix[line]   = fix( (((lines[line]*1.005)-firstlam)/dlam) + firstpix )
endif
  



IF ( (startpix[line] ge 0) and (endpix[line] lt sz[1]) ) THEN BEGIN ; Line is in the spectrum


        if ~defined(bandJ) then begin
           data = spec1d[startpix[line]:endpix[line]]*1.d0

           model = gaussfit(wave[startpix[line]:endpix[line]],data,A)

                                  ESTIMATEs=A
                                                              ;  if line eq 14 then    ESTIMATES[2]=20

                                  if line eq 15 then    ESTIMATES[2]=200
                                  
                       model = gaussfit(wave[startpix[line]:endpix[line]],data,A)
                       xxx=wave[startpix[line]:endpix[line]]
                       modx[startpix[line]:endpix[line]]=model
                       spec1d_sub =spec1df-modx
               spec1df[startpix[line]:endpix[line]]=spec1d_sub[startpix[line]:endpix[line]]+A[3]+A[4]*xxx+A[5]*xxx^2
        endif
        
        if defined(bandJ) then begin
                      data = spec1d[startpix[line]:endpix[line]]*1.d0
                       model = gaussfit(wave[startpix[line]:endpix[line]],data,A)
                       xw=wave[startpix[line]:endpix[line]]
;;                  model = A[0]*exp(-0.5*((x-A[1])/A[2])^2)          
                     modx[startpix[line]:endpix[line]]=model
                       spec1d_sub =spec1df-modx
              ; smok=where(xw gt 12796 and xw lt 12855.,ccc)  ;;;dirty work
              ; spec1d_sub[smok]=1;median(spec1d_sub[smok])
              ;spec1df[startpix[line]:endpix[line]]=spec1d_sub[startpix[line]:endpix[line]]+median(spec1df[startpix[line]:endpix[line]])
               spec1df[startpix[line]:endpix[line]]=spec1d_sub[startpix[line]:endpix[line]]+A[3]+A[4]*xw+A[5]*xw^2

  ;;; broad wings
                ESTIMATEs=[-1200,12826,200.,32600,-0.9,1.e-6]
                       data = spec1df[startpix[line]:endpix[line]]*1.d0
                      ;e data=median(data,5)
                       model = gaussfit(wave[startpix[line]:endpix[line]],data,A,ESTIMATES=ESTIMATES)
           ;    model = gaussfit(wave[startpix[line]:endpix[line]],data,A,nterms=4)
                         xw= wave[startpix[line]:endpix[line]]             
                         modxb[startpix[line]:endpix[line]]=model
;; plot,wave[startpix[line]:endpix[line]],data,color=2
;; oplot,wave[startpix[line]:endpix[line]],model,color=4
;; stop
                          spec1d_sub =spec1df-modxb
         ;     spec1df[startpix[line]:endpix[line]]=spec1d_sub[startpix[line]:endpix[line]]+A[3]
                spec1df[startpix[line]:endpix[line]]=smooth(spec1d_sub[startpix[line]:endpix[line]],5)+median(spec1df[startpix[line]:endpix[line]])
             ;   spec1df[startpix[line]:endpix[line]]=spec1d_sub[startpix[line]:endpix[line]]+A[3]+A[4]*xw+A[5]*xw^2
  
              smok=where(wave gt 12803.1 and wave lt 12862.1,ccc)  ;;;dirty work of removing extra profiles
               spec1df[smok]=modxb[smok];
        
      endif




          
  ENDIF
        
ENDFOR


ENDIF

;stop

if (defined(usespec)) then begin
;spec1df=spec1d
endif

slength=3*5
spec1df=median(spec1df,slength)
;spec1df=smooth(spec1df,3)
if defined(bandK) then begin
okn=where(finite(spec1df,/NAN) OR wave le 1.97e4 OR wave gt 2.4e4,complement=okp)
endif 

if defined(bandH) then begin
okn=where(finite(spec1df,/NAN) OR wave le 1.45e4 OR wave gt 1.7949e4,complement=okp)
endif


if defined(bandY) then begin
okn=where(finite(spec1df,/NAN) OR wave le 9755. OR wave gt 11240.,complement=okp)
endif

if (~defined(usespec)) then begin
if keyword_set(plotyes) then window,2
if keyword_set(plotyes) then plot,wave,spec1df,charsize=2,color=3,xra=[min(wave),max(wave)],yra=[min(spec1df[okp])-1,max(spec1df[okp])+1],/xs,/ys,title='Hdydrogen lines removed',thick=2
;;;if keyword_set(plotyes) then oplot,wave,modx,color=2
;;if keyword_set(plotyes) then oplot,wave,spec1df,color=5
; writefits,fluxpath+'flux_1D_Hdyrm.fits',spec1df,header

temp=temp;9480.d0  ;;  USE A0 temperature of 9480 as default

temperature=temp 
       lam = dlam*(x-firstpix)+firstlam  ; Wavelength at each pixel
       lam = lam/1.d10 ; Wavelengths in meters
       dlam=dlam/1.d10 ; delta lam in meters
       hcokt = 0.014397/temperature
       bb = 1.0/(lam*lam*lam*lam*lam)
       bb = bb / (exp(hcokt/lam)-1.0)  ; This is proportional to flux
       mn = mean(bb) ; Calculate mean of bb
       bb = bb / mn
if keyword_set(plotyes) then window, 3
spec1df_div=spec1df/bb



if keyword_set(plotyes) then plot,wave,spec1df_div,charsize=2,color=3,xra=[min(wave),max(wave)],yra=[min(spec1df_div[okp])-1,max(spec1df_div[okp])+1],/xs,/ys,title=' B-body divided (yellow)'
if keyword_set(plotyes) then oplot,wave,spec1df,color=2
;if keyword_set(plotyes) then oplot,wave,spec1df_div,color=5
 



  writefits,fluxpath+bbname,spec1df_div,header ;
  writefits,fluxpath+bbname_wave,wave,header

 xmin=19210. & xmax=24038.
oplot,[xmin,xmin],[-1.e9,1.e9],linestyle=2,color=2
oplot,[xmax,xmax],[-1.e9,1.e9],linestyle=2,color=2
oplot,[(xmin+xmax)/2,(xmin+xmax)/2],[-1.e9,1.e9],linestyle=2,color=2

xyouts,(xmin+xmax)/2,max(spec1df_div)*0.59,'K-band center',color=2,charsize=1.5
;stop


 xmin=11500. & xmax=13500.
oplot,[xmin,xmin],[-1.e9,1.e9],linestyle=2,color=3
oplot,[xmax,xmax],[-1.e9,1.e9],linestyle=2,color=3
oplot,[(xmin+xmax)/2,(xmin+xmax)/2],[-1.e9,1.e9],linestyle=2,color=3

xyouts,(xmin+xmax)/2,max(spec1df_div)*0.59,'J-band center',color=3,charsize=1.5

 xmin=14600. & xmax=18100.
oplot,[xmin,xmin],[-1.e9,1.e9],linestyle=2,color=5
oplot,[xmax,xmax],[-1.e9,1.e9],linestyle=2,color=5
oplot,[(xmin+xmax)/2,(xmin+xmax)/2],[-1.e9,1.e9],linestyle=2,color=5

xyouts,(xmin+xmax)/2,max(spec1df_div)*0.59,'H-band center',color=5,charsize=1.5



;;; I faked Y band =>need to be revised to get real flux calibration
if defined(bandY) then begin
j_zero=3.129d-09*1d7/1d4/1d4     ; conver from W/m2/um -> erg/cm2/A
j_wave=1.12*1d4                ; 1.25 um to Ang, of effective J-band wavelength
mag=magJ;8.814
endif


;;;
if defined(bandJ) then begin
j_zero=3.129d-09*1d7/1d4/1d4     ; conver from W/m2/um -> erg/cm2/A
j_wave=1.2350*1d4                ; 1.25 um to Ang, of effective J-band wavelength
mag=magJ;8.814
endif

if defined(bandH) then begin
j_zero=1.133e-09*1e7/1e4/1e4     ; conver from W/m2/um -> erg/cm2/A
j_wave=1.662*1e4                ; 1.25 um to Ang, of effective J-band wavelength
mag=magH
endif 

if defined(bandK) then begin
j_zero=0.4283e-09*1e7/1e4/1e4     ; conver from W/m2/um -> erg/cm2/A
j_wave=2.159*1e4                ; 1.25 um to Ang, of effective J-band wavelength
mag=magK;8.814
endif

;;bb=planck(wave,teff)            ; blackbody as an intrinsic shape, in units of erg/cm^2/s/A
; plot,wave,bb
J_wave_index=where(abs(wave-j_wave) EQ min(abs(wave-j_wave)),count)
if count ne 1 then stop
bb_j=bb[J_wave_index[0]]
j_flux=j_zero*10.^(mag/(-2.5))





;gain=2.15d
fluxconvt=(exposure_star/gain)*j_flux/bb_j

if keyword_set(plotyes) then print,' Flux conversion factor =  ',fluxconvt


stop,'@moscali_flux... If you are happy with the flux conversion factor, type .continue to  proceed to actual flux calibration ...' 
wdelete,0
if keyword_set(plotyes) then begin
wdelete,1
wdelete,2
wdelete,3
endif
;window,0
;stop




endif



if (defined(usespec)) then begin
if keyword_set(plotyes) then window,2
if keyword_set(plotyes) then plot,wave,spec1df,charsize=2,color=3,xra=[min(wave),max(wave)],yra=[min(spec1df[okp])-1,max(spec1df[okp])+1],/xs,/ys,title='Match with Flux Standard spectrum',thick=4
;;;if keyword_set(plotyes) then oplot,wave,modx,color=2
;;if keyword_set(plotyes) then oplot,wave,spec1df,color=5

;scalex=1.41347d+16
readcol,filestd,wv,bdspec,format='(d,d)',skipline=1
wv=wv*1.
 bdspec_rebin=interpol(bdspec,wv,wave) ; linear interpol without any options
scale_lam=bdspec_rebin-bdspec_rebin
nwave=n_elements(scale_lam)
for iii=0,nwave-1 do begin
;scale_lam[iii]*bdspec_rebin[iii]=spec1d[iii]/(exposure_star/gain)
scale_lam[iii]=spec1df[iii]/bdspec_rebin[iii]/(exposure_star/gain)
endfor
if keyword_set(plotyes) then oplot,wave,bdspec_rebin*scale_lam,color=2;,thick=6

writefits,fluxpath+'flux_1D_scale.fits',scale_lam
writefits,fluxpath+'flux_1D_scale_lam.fits',wave
;stop

endif





END
